unit UCMenu;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Menus, CheckLst;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Arquivo1: TMenuItem;
    este1: TMenuItem;
    Sobre1: TMenuItem;
    Abrir1: TMenuItem;
    Fechar1: TMenuItem;
    N1: TMenuItem;
    Sair1: TMenuItem;
    estado1: TMenuItem;
    NoTestado1: TMenuItem;
    Ajuda1: TMenuItem;
    BrasPastanna1: TMenuItem;
    Geninho1: TMenuItem;
    SubdoFechar1: TMenuItem;
    OutroSubdoFechar1: TMenuItem;
    CheckListBox1: TCheckListBox;
    estadoando1: TMenuItem;
    estadinho1: TMenuItem;
    NoTestado2: TMenuItem;
    Geninhosub11: TMenuItem;
    GeninhoSub21: TMenuItem;
    GeninhoSub31: TMenuItem;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Ajuda2: TMenuItem;
    Sub1Ajuda1: TMenuItem;
    Sub2Ajuda1: TMenuItem;
    Sub1Sub2Ajuda1: TMenuItem;
    Sub2Sub2Ajuda1: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    {A funo abaixo usar no create do form do controle de usurio}
    function MainMenu_To_CheckListBox(iMainMenu: TMainMenu; iCheckList: TCheckListBox): string;
    {A funo abaixo deve ser chamada antes da gravar em tabela}
    function CheckListBox_Marcados(iCheckList: TCheckListBox): TStringList;
    {A funco seguinte use em boto para retornar a situao anterior ou inicial}
    function Desmarca_o_CheckListBox(iCheckList: TCheckListBox): string;
    {Esta deve ser chamada aps j estar em memora a sua lista de itens que foi selecionado }
    function Marca_CheckListBox_a_partir_ListaMemorizada(iCheckList: TCheckListBox; wList: TStringList): string;
    {E esta, logo a seguir}
    function Aplicar_no_MainMenu_a_ListaMemorizada(iMainMenu: TMainMenu; zList: TStringList): string;
    {Esta  usada dentro da "MainMenu_To_CheckListBox"}
    function Remove_e_comercial(iTxt: TCaption): TCaption;
  end;

var
  Form1: TForm1;
  iList: TStringList;
  mList : TStringList; // Usado o anteriormente foi marcado,
implementation

{$R *.dfm}

function TForm1.Aplicar_no_MainMenu_a_ListaMemorizada(iMainMenu: TMainMenu;
  zList: TStringList): string;
var
  z: integer;
  iPack: string;
  iItem: Integer;
  iMenu: Array [0..6] of integer;
  iCount: integer;
  i, ii, iii, iiii, iiiii: Integer;
begin
  //Ativa todos os Menus
  for i := 0 to iMainMenu.Items.count-1 do
  begin
    iMainMenu.Items.Items[i].Enabled := True;
    for ii := 0 to iMainMenu.Items.Items[i].Count-1 do
    begin
      iMainMenu.Items.Items[i].Items[ii].Enabled := True;
      for iii := 0 to iMainMenu.Items.Items[i].Items[ii].Count-1 do
      begin
        iMainMenu.Items.Items[i].Items[ii].Items[iii].Enabled := True;
        for iiii := 0 to iMainMenu.Items.Items[i].Items[ii].Items[iii].Count-1 do
        begin
          iMainMenu.Items.Items[i].Items[ii].Items[iii].Items[iiii].Enabled := True;
          for iiiii := 0 to iMainMenu.Items.Items[i].Items[ii].Items[iii].Items[iiii].Count-1 do
          begin
            iMainMenu.Items.Items[i].Items[ii].Items[iii].Items[iiii].Items[iiiii].Enabled := True;
          end;
        end;
      end;
    end;
  end;

  //Desativa conforme lista memorizada
  for z := 0 to zList.Count-1 do
  begin
    iPack := zList.Strings[z]+'-';
    iPack := copy(iPack,pos(',',iPack)+1,length(iPack));

    iCount := 0;
    while pos('-',iPack) > 0 do
    begin
      iItem := StrToInt(copy(iPack, 1, pos('-',iPack)-1));
      iMenu[iCount] := iItem;
      iPack := copy(iPack,pos('-',iPack)+1,length(iPack));
      Inc(iCount);
    end;

    if iCount = 1 then
       iMainMenu.Items.Items[iMenu[0]].Enabled := False
    else if iCount = 2 then
       iMainMenu.Items.Items[iMenu[0]].Items[iMenu[1]].Enabled := False
    else if iCount = 3 then
       iMainMenu.Items.Items[iMenu[0]].Items[iMenu[1]].Items[iMenu[2]].Enabled := False
    else if iCount = 4 then
       iMainMenu.Items.Items[iMenu[0]].Items[iMenu[1]].Items[iMenu[2]].Items[iMenu[3]].Enabled := False
    else if iCount = 5 then
       iMainMenu.Items.Items[iMenu[0]].Items[iMenu[1]].Items[iMenu[2]].Items[iMenu[3]].Items[iMenu[3]].Enabled := False
    else if iCount = 6 then
       iMainMenu.Items.Items[iMenu[0]].Items[iMenu[1]].Items[iMenu[2]].Items[iMenu[3]].Items[iMenu[4]].Items[iMenu[5]].Enabled := False
    else if iCount = 7 then
       iMainMenu.Items.Items[iMenu[0]].Items[iMenu[1]].Items[iMenu[2]].Items[iMenu[3]].Items[iMenu[4]].Items[iMenu[5]].Items[iMenu[6]].Enabled := False;

  end;

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  iList := CheckListBox_Marcados(CheckListBox1);
  mList := iList;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Marca_CheckListBox_a_partir_ListaMemorizada(CheckListBox1, mList);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  Desmarca_o_CheckListBox(CheckListBox1);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Aplicar_no_MainMenu_a_ListaMemorizada(MainMenu1, mList);
end;


function TForm1.MainMenu_To_CheckListBox(iMainMenu: TMainMenu;
  iCheckList: TCheckListBox): string;
var
  i, ii, iii, iiii, iiiii : integer;
begin
  //Adiciona todos os MainMenus de at 5 nveis em checklistbox
  iCheckList.Items.Clear;
  for i := 0 to iMainMenu.Items.Count-1 do
  begin
    iCheckList.Items.Append(IntTostr(i)+ ':'+ Remove_e_comercial(iMainMenu.Items.Items[i].Caption));
    for ii := 0 to iMainMenu.Items.Items[i].Count-1 do
    begin
      iCheckList.Items.Append(IntTostr(i)+'-'+ IntTostr(ii)+ ':'+ Remove_e_comercial(iMainMenu.Items.Items[i].Items[ii].Caption));
      for iii := 0 to iMainMenu.Items.Items[i].Items[ii].Count-1 do
      begin
        iCheckList.Items.Append(IntTostr(i)+'-'+ IntTostr(ii)+ '-'+IntTostr(iii)+':'+ Remove_e_comercial(iMainMenu.Items.Items[i].Items[ii].Items[iii].Caption));
        for iiii := 0 to iMainMenu.Items.Items[i].Items[ii].items[iii].Count-1 do
        begin
          iCheckList.Items.Append(IntTostr(i)+'-'+ IntTostr(ii)+'-'+ IntTostr(iii) + '-'+IntTostr(iiii) + ':'+ Remove_e_comercial(iMainMenu.Items.Items[i].Items[ii].Items[iii].items[iiii].Caption));
          for iiiii := 0 to iMainMenu.Items.Items[i].Items[ii].items[iii].items[iiii].Count-1 do
          begin
            iCheckList.Items.Append(IntTostr(i)+'-'+ IntTostr(ii)+ '-'+IntTostr(iii) + '-'+IntTostr(iiii) + '-'+IntTostr(iiiii) +':'+ Remove_e_comercial(iMainMenu.Items.Items[i].Items[ii].Items[iii].items[iiii].items[iiiii].Caption));
          end;
        end;
      end;
    end;
  end;

  Application.ProcessMessages;
end;

function TForm1.CheckListBox_Marcados(iCheckList: TCheckListBox): TStringList;
var
  z: integer;
  zList: TStringList;
begin
  {Esta funo captura somente os itens do checklistbox que esto marcados}
  zList := TStringList.Create;
  zList.Clear;
  for z := 0 to iCheckList.Items.Count-1 do
  begin
    if iCheckList.Checked[z] then
    begin
       //Como fica o contedo guardado: 0,0
       //                               1,0-0
       //                               2,0-1
       //Entendendo: O nmero antes da vrgula  o Index do CheckListBox, e aps a vrgula refere-se os menus e submenus.

       zList.Append(IntToStr(z)+',' + copy(iCheckList.Items.Strings[z],1,pos(':',iCheckList.Items.Strings[z])-1))
    end;
  end;
  Result := zList; 
end;

function TForm1.Desmarca_o_CheckListBox(iCheckList: TCheckListBox): string;
var
  z: integer;
begin
  //Limpa os checklistbox as marcaes do chechlistbox
  for z := 0 to iCheckList.Items.Count-1 do
     iCheckList.Checked[z] := False;
end;

function TForm1.Marca_CheckListBox_a_partir_ListaMemorizada(iCheckList: TCheckListBox; wList: TStringList): string;
var
  z: integer;
  iPack: string;
  iItem: Integer;
begin
  {Esta funo  para ser usada quando, caso voc tenha alterado os
   items marcados no checklistbox, e queira retornar ao que j estava marcado
   anteriormente}
  for z := 0 to mList.Count-1 do
  begin
    iPack := mList.Strings[z];
    iItem := StrToInt(copy(iPack, 1, pos(',',iPack)-1));
    iCheckList.Checked[iItem] := True;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  iList := TStringList.Create();
  mList := TStringList.Create();
  MainMenu_To_CheckListBox(MainMenu1,CheckListBox1);
end;

function TForm1.Remove_e_comercial(iTxt: TCaption): TCaption;
var
  S: string;
begin
  //Remove o "&" dos TCaption
  S := iTxt;
  while Pos('&',S) > 0 do
    delete(s,Pos('&',S),1);

  Result := S;
end;

end.
